<?php
/**

This file is provided as part of "My Coloring Book" by Kea Software.

The file accepts image data from the coloring book, saves it to a 
predetermined directory, and returns the name of the saved file.

DISCLAIMER:

This script is provided as-is, for your convenience, to use and modify as 
needed. No warranties either express or implied are given.

**/
define('OUTPUT_DIR', 'save/');

function unique($ext) 
{
  if (array_key_exists('REMOTE_ADDR', $_SERVER)) {
    $ip = explode('.', $_SERVER['REMOTE_ADDR']);
  } else {
    $ip = array(mt_rand(0, 255), mt_rand(0, 255), mt_rand(0, 255), mt_rand(0, 255));
  }
  $ip = ($ip[3] << 24) | ($ip[2] << 16) | ($ip[1] << 8) | $ip[0];
  list($usec, $sec) = explode(' ', microtime());
  $usec = (integer) ($usec * 65536);
  $sec = ((integer) $sec) & 0xFFFF;
  $uid = sprintf("%08x-%04x-%04x", $ip, $sec, $usec);
  return $uid . $ext;
}

if ($_POST['imgType'] == "image/png") {
  $ext = ".png";
} else {
  $ext = ".jpeg";
}
$file = OUTPUT_DIR . unique($ext);
$fp = fopen($file, 'w');
fwrite($fp, base64_decode($_POST['data']));
fclose($fp);

echo $file;
?>